> For the complete documentation index, see [llms.txt](https://developers-apps-in-toss.toss.im/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers-apps-in-toss.toss.im/documentation/api-and-sdk-en/sdk/domains-api/iap/iap.getproductitemlist.md).

# IAP.getProductItemList

### Feature description

Fetches the list of products available for purchase via in-app purchase. Called when entering the product list screen.

Toss app Android/iOS `5.219.0` It can be used on versions above. If called in an unsupported version, `UNSUPPORTED_APP_VERSION` an error occurs.

### Type

```ts
IAP.getProductItemList(): Promise<{ products: IapProductListItem[] }>;
```

**Params**

None

**Response**

```ts
type ConsumableProductListItem = {
  sku: string;
  type: "CONSUMABLE";
  displayName: string;
  displayAmount: string;
  iconUrl: string;
  description: string;
};

type NonConsumableProductListItem = {
  sku: string;
  type: "NON_CONSUMABLE";
  displayName: string;
  displayAmount: string;
  iconUrl: string;
  description: string;
};

type Offer =
  | { type: "FREE_TRIAL"; offerId: string; period: string }
  | {
      type: "NEW_SUBSCRIPTION";
      offerId: string;
      period: string;
      displayAmount: string;
    }
  | {
      type: "RETURNING";
      offerId: string;
      period: string;
      displayAmount: string;
    };

type SubscriptionProductListItem = {
  sku: string;
  type: "SUBSCRIPTION";
  displayName: string;
  displayAmount: string;
  iconUrl: string;
  description: string;
  renewalCycle: "WEEKLY" | "MONTHLY" | "YEARLY";
  offers?: Offer[];
};

type IapProductListItem =
  | ConsumableProductListItem
  | NonConsumableProductListItem
  | SubscriptionProductListItem;
```

### Error

The error code is the `error.code` value.

| Code                      | Description                                                                                                                                                                                                                                      |
| ------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| `UNSUPPORTED_APP_VERSION` | If the running version of the Toss app doesn't support this feature, it occurs immediately upon call. `IAP.getProductItemList.isSupported()`Check in advance with `error.message`and, if it occurs, show the user the (update guidance message). |

### Example code

```js
import { IAP } from "@apps-in-toss/web-framework";

async function renderProductList() {
  try {
    const response = await IAP.getProductItemList();
    const list = document.querySelector("#product-list");

    for (const product of response.products) {
      const item = document.createElement("li");
      item.textContent = `${product.displayName} · ${product.displayAmount}`;
      list.appendChild(item);
    }
  } catch (error) {
    console.error(error);
  }
}

renderProductList();
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://developers-apps-in-toss.toss.im/documentation/api-and-sdk-en/sdk/domains-api/iap/iap.getproductitemlist.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
